X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/5c2fca9c11b587c2c34ca52f65872056aa9c1b74..e98b51e220feeca897582e1dd879ebc76e5f6dfd:/vcsh?ds=inline

diff --git a/vcsh b/vcsh
index c05210d..3e2a6b6 100755
--- a/vcsh
+++ b/vcsh
@@ -1,40 +1,123 @@
 #!/bin/sh
 
-[ -n "$VCSH_DEBUG" ]      && set -x
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+# This program is licensed under the GNU GPL version 2 or later.
+# (c) Richard "RichiH" Hartmann <richih@debian.org>, 2011-2013
+# For details, see LICENSE. To submit patches, you have to agree to
+# license your code under the GNU GPL version 2 or later.
+
+# While the following is not legally binding, the author would like to
+# explain the choice of GPLv2+ over GPLv3+.
+# The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
+# full compatibility's with Git. In case Git ever changes its licensing terms,
+# which is admittedly extremely unlikely to the point of being impossible,
+# this software will most likely follow suit.
+
+# This should always be the first line of code to facilitate debugging
+[ -n "$VCSH_DEBUG" ] && set -vx
+
+basename() {
+	# Implemented in shell to avoid spawning another process
+	local file
+	file="${1##*/}"
+	[ -z "$2" ] || file="${file%$2}"
+	echo "$file"
+}
 
 SELF=$(basename $0)
-if [ "$SELF" = 'bash' ] ||
-   [ "$SELF" = 'dash' ] ||
-   [ "$SELF" = 'sh' ] ||
-   [ "$SELF" = 'zsh' ]; then
-	SELF='vcsh'
-	VCSH_SOURCED=1
+VERSION='1.20130724'
+
+fatal() {
+	echo "$SELF: fatal: $1" >&2
+	exit $2
+}
+
+# We need to run getops as soon as possible so we catch -d and other
+# options that will modify our behaviour.
+# Commands are handled at the end of this script.
+while getopts "c:dv" flag; do
+	if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
+		set -vx
+		VCSH_DEBUG=1
+		echo "debug mode on"
+		echo "$SELF $VERSION"
+	elif [ "$1" = '-v' ];then
+		VCSH_VERBOSE=1
+		echo "verbose mode on"
+		echo "$SELF $VERSION"
+	elif [ "$1" = '-c' ];then
+		VCSH_OPTION_CONFIG=$OPTARG
+	fi
+	shift 1
+done
+
+source_all() {
+	# Source file even if it's in $PWD and does not have any slashes in it
+	case "$1" in
+		*/*) . "$1";;
+		*)   . "$PWD/$1";;
+	esac;
+}
+
+
+# Read configuration and set defaults if anything's not set
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+
+# Read configuration files if there are any
+[ -r "/etc/vcsh/config" ]             && . "/etc/vcsh/config"
+[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+if [ -n "$VCSH_OPTION_CONFIG" ]; then
+	# Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
+	if [ -r "$VCSH_OPTION_CONFIG" ]; then
+		source_all "$VCSH_OPTION_CONFIG"
+	else
+		fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
+	fi
 fi
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+
+# Read defaults
+[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
+[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
+[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
+[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
 
 
 help() {
-	echo "usage: $SELF <args>
+	echo "usage: $SELF <options> <command>
+
+   options:
+   -c <file>            Source file
+   -d                   Enable debug mode
+   -v                   Enable verbose mode
 
+   commands:
    clone <remote> \\
          [<repo>]       Clone from an existing repository
+   commit               Commit in all repositories
+   delete <repo>        Delete an existing repository
+   enter <repo>         Enter repository; spawn new instance of \$SHELL
    help                 Display this help text
-   delete               Delete an existing repository
-   enter                Enter repository; spawn new $SHELL
-   exit                 Exit repository; unset ENV
    init <repo>          Initialize a new repository
    list                 List all repositories
+   list-tracked         List all files tracked by vcsh
+   list-tracked-by \\
+        <repo>          List files tracked by a repository
+   pull                 Pull from all vcsh remotes
+   push                 Push to vcsh remotes
+   rename <repo> \\
+          <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
-
-   seed-gitignore \\
-   <repo>               Seed .gitignore.d/<repo> from git ls-files
-   setup                Set up repository with recommended settings
-   use <repo>           Use repository; set ENV
-
-   <repo> <git command> Special command that allows you to run git commands
-                        directly without having to type so much ;)" >&2
+   status [<repo>]      Show statuses of all/one vcsh repositories
+   upgrade <repo>       Upgrade repository to currently recommended settings
+   version              Print version information
+   which <substring>    Find substring in name of any tracked file
+   write-gitignore \\
+   <repo>               Write .gitignore.d/<repo> via git ls-files
+
+   <repo> <git command> Shortcut to run git commands directly
+   <repo>               Shortcut to enter repository" >&2
 }
 
 debug() {
@@ -45,194 +128,220 @@ verbose() {
 	if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-setup() {
-	git config core.worktree     "$GIT_WORK_TREE"
-	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-	git config vcsh.vcsh         'true'
-	touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-	git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+error() {
+	echo "$SELF: error: $1" >&2
 }
 
-init() {
-	verbose "init() begin"
-	[ -e "$GIT_DIR" ] &&
-		echo "$SELF: fatal: $GIT_DIR exists" &&
-		return 21
-	export GIT_WORK_TREE="$HOME"
-	mkdir -p "$GIT_WORK_TREE"
-	cd "$GIT_WORK_TREE" ||
-		(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-		 return 1) || return $?
-	cd "$GIT_WORK_TREE"
-	git init
-	setup
-	verbose "init() end"
+info() {
+	echo "$SELF: info: $1"
 }
 
-leave() {
-	unset GIT_DIR
-	unset GIT_WORK_TREE
-	unset VCSH_DIRECTORY
-}
-
-use() {
-	verbose "use() begin"
-	if [ ! -d "$GIT_DIR" ]; then
-		echo E: no repository found for "$VCSH_REPO_NAME" >&2
-		return 1
-	fi
-	export GIT_DIR
-	export GIT_WORK_TREE="$(git config --get core.worktree)"
-	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
-	verbose "use() end"
-}
-
-
-if [ "$1" = 'clone' ]; then
-	export VCSH_COMMAND="$1"
-	GIT_REMOTE="$2"
-	export GIT_REMOTE
-	VCSH_REPO_NAME="$3"
-	[ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
-	export VCSH_REPO_NAME
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
-     [ "$1" = 'enter' ] ||
-     [ "$1" = 'init' ] ||
-     [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ] ||
-     [ "$1" = 'setup' ] ||
-     [ "$1" = 'use' ]; then
-	[ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
-	export VCSH_COMMAND="$1"
-	export VCSH_REPO_NAME="$2"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-	shift 2
-	export VCSH_EXTERNAL_COMMAND="$*"
-	if [ "$VCSH_COMMAND" = 'run' ]; then
-		[ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
-	fi
-elif [ "$1" = 'exit' ] ||
-     [ "$1" = 'help' ] ||
-     [ "$1" = 'list' ]; then
-	export VCSH_COMMAND="$1"
-else
-	[ -z $1 ] && help && return 0
-	export VCSH_COMMAND='run'
-	export VCSH_REPO_NAME="$1"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-	[ -d $GIT_DIR ] || (help && return 1) || return 0
-	shift 1
-	export VCSH_EXTERNAL_COMMAND="git $*"
-fi
-
-
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
-do
-	if [ ! -d "$check_directory" ]; then
-		if [ -e "$check_directory" ]; then
-			echo "$SELF: error: $check_directory exists but is not a directory" >&2
-			return 2
-		else
-			echo "$SELF: info: attempting to create $check_directory"
-			mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
-		fi
-	fi
-done
-
-
-if [ "$VCSH_COMMAND" = 'clone' ]; then
-	verbose "clone begin"
+clone() {
+	hook pre-clone
 	init
 	git remote add origin "$GIT_REMOTE"
 	git config branch.master.remote origin
 	git config branch.master.merge  refs/heads/master
+	if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
+		info "remote is empty, not merging anything"
+		exit
+	fi
 	git fetch
 	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
 		[ -e "$object" ] &&
-			echo "$SELF: error: $object exists." &&
+			error "'$object' exists." &&
 			VCSH_CONFLICT=1;
 	done
 	[ "$VCSH_CONFLICT" = '1' ] &&
-		echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-		echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-		return 3
+		fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
 	git merge origin/master
-#	use || return $?
-	verbose "clone end"
-
-#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
-elif [ "$VCSH_COMMAND" = 'help' ]; then
-	help
-
-elif [ "$VCSH_COMMAND" = 'delete' ]; then
-	verbose "delete begin"
-	old_dir="$PWD"
-	cd "$HOME"
-	use || return $?
-	echo "$SELF: info: This operation WILL DETROY DATA!"
+	hook post-clone
+	retire
+	hook post-clone-retired
+}
+
+commit() {
+	hook pre-commit
+	for VCSH_REPO_NAME in $(list); do
+		echo "$VCSH_REPO_NAME: "
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git commit --untracked-files=no --quiet
+		echo
+	done
+	hook post-commit
+}
+
+delete() {
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
+	use
+	info "This operation WILL DESTROY DATA!"
 	files=$(git ls-files)
 	echo "These files will be deleted:
 
 $files
 
 AGAIN, THIS WILL DELETE YOUR DATA!
-To continue, type \"Yes, do as I say\""
+To continue, type 'Yes, do as I say'"
 	read answer
-	[ "x$answer" = "xYes, do as I say" ] || return 1
+	[ "x$answer" = 'xYes, do as I say' ] || exit 16
 	for file in $files; do
-		rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+		rm -f $file || info "could not delete '$file', continuing with deletion"
 	done
-	rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
-	cd "$old_dir"
-	verbose "delete end"
+	rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
+}
 
-elif [ "$VCSH_COMMAND" = 'enter' ]; then
-	verbose "enter begin"
-	use || return $?
+enter() {
+	hook pre-enter
+	use
 	$SHELL
-	leave
-	verbose "enter end"
-
-elif [ "$VCSH_COMMAND" = 'exit' ]; then
-	verbose "exit begin"
-#	if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-#		unset VCSH_NO_IGNORE_EOF
-#		setopt NO_IGNORE_EOF
-#	fi
-	[ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
-	leave
-#	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-	verbose "exit end"
-	return 0
-
-elif [ "$VCSH_COMMAND" = 'init' ]; then
-	verbose "init begin"
-	init
-#	use || return $?
-	verbose "init end"
+	hook post-enter
+}
+
+git_dir_exists() {
+	[ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
+}
+
+hook() {
+	for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+		[ -x "$hook" ] || continue
+		verbose "executing '$hook'"
+		"$hook"
+	done
+}
+
+init() {
+	hook pre-init
+	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+	export GIT_WORK_TREE="$VCSH_BASE"
+	mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
+	cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+	git init
+	upgrade
+	hook post-init
+}
 
-elif [ "$VCSH_COMMAND" = 'list' ]; then
-	verbose "list begin"
-	for i in "$VCSH_BASE"/*.git; do
-		echo $(basename "$i" .git)
+list() {
+	for repo in "$VCSH_REPO_D"/*.git; do
+		[ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
 	done
-	verbose "list end"
-
-elif [ "$VCSH_COMMAND" = 'run' ]; then
-	verbose "run begin"
-	use || return $?
-	$VCSH_EXTERNAL_COMMAND
-	leave
-	verbose "run end"
-
-elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
-	verbose "seed-gitignore begin"
-	use || return $?
-	# Switching directory as this has to be executed from $HOME to be of any use.
-	# Going back into old directory at the end in case `vcsh use` is reactivated.
-	old_dir="$PWD"
-	cd "$HOME"
+}
+
+get_files() {
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	git ls-files
+}
+
+list_tracked() {
+	for VCSH_REPO_NAME in $(list); do
+		get_files
+	done | sort -u
+}
+
+list_tracked_by() {
+	use
+	git ls-files | sort -u
+}
+
+pull() {
+	hook pre-pull
+	for VCSH_REPO_NAME in $(list); do
+		echo -n "$VCSH_REPO_NAME: "
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git pull
+		echo
+	done
+	hook post-pull
+}
+
+push() {
+	hook pre-push
+	for VCSH_REPO_NAME in $(list); do
+		echo -n "$VCSH_REPO_NAME: "
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git push
+		echo
+	done
+	hook post-push
+}
+
+retire() {
+	unset GIT_WORK_TREE
+	unset VCSH_DIRECTORY
+}
+
+rename() {
+	git_dir_exists
+	[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+	mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+
+	# Now that the repository has been renamed, we need to fix up its configuration
+	# Overwrite old name..
+	GIT_DIR="$GIT_DIR_NEW"
+	$VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
+	# ..and clobber all old configuration
+	upgrade
+}
+
+run() {
+	hook pre-run
+	use
+	"$@"
+	hook post-run
+}
+
+status() {
+	if [ ! "x$VCSH_REPO_NAME" = "x" ]; then
+		export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+		use
+		git status --short --untracked-files='no'
+	else
+		for VCSH_REPO_NAME in $(list); do
+			echo "$VCSH_REPO_NAME:"
+			export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+			use
+			git status --short --untracked-files='no'
+			echo
+		done
+	fi
+}
+
+upgrade() {
+	hook pre-upgrade
+	use
+	git config core.worktree     "$GIT_WORK_TREE"
+	[ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh         'true'
+	[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+	hook post-upgrade
+}
+
+use() {
+	git_dir_exists
+	export GIT_WORK_TREE="$(git config --get core.worktree)"
+	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+which() {
+	for VCSH_REPO_NAME in $(list); do
+		for VCSH_FILE in $(get_files); do
+			echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
+		done
+	done | sort -u
+}
+
+write_gitignore() {
+	# Don't do anything if the user does not want to write gitignore
+	if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
+		info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
+		exit
+	fi
+
+	use
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
 	gitignores=$(for file in $(git ls-files); do
 		while true; do
 			echo $file; new="${file%/*}"
@@ -240,57 +349,129 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 			file="$new"
 		done;
 	done | sort -u)
-	tempfile=$(mktemp) ||
-		(echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
-	echo '*' > "$tempfile"
+	tempfile=$(mktemp) || fatal "could not create tempfile" 51
+	echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
 	for gitignore in $gitignores; do
-		echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
-		[ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
+		echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+		if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
+			{ echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+		fi
 	done
-	diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
-		rm -f "$tempfile" &&
-		return
-	if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
-		echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
-		mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-			(echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
-			 return 1) || return $?
+	if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
+		rm -f "$tempfile" || error "could not delete '$tempfile'"
+		exit
+	fi
+	if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
+		info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
+		mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+			fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
 	fi
-	mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-		(echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
-	cd "$old_dir"
-	verbose "seed-gitignore end"
-
-elif [ "$VCSH_COMMAND" = 'setup' ]; then
-	verbose "seed-gitignore begin"
-	use   || return $?
-	setup || return $?
-	leave
-	verbose "seed-gitignore end"
-
-elif [ "$VCSH_COMMAND" = 'use' ]; then
-	verbose "use begin"
-#	if [ -n "$ZSH_VERSION" ]; then
-#		if [ -o NO_IGNORE_EOF ]; then
-#			export VCSH_NO_IGNORE_EOF=1
-#			setopt IGNORE_EOF
-#		fi
-#		vcsh_exit() {
-#			vcsh exit;
-#			zle reset-prompt;
-#		}
-#		zle -N vcsh_exit
-#		bindkey '^d' 'vcsh_exit'
-#	fi
-	[ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
-	use || return $?
-#	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-	verbose "use end"
+	mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
+		fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
+}
+
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+	fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'none', or 'recursive'" 1
+fi
+
+export VCSH_COMMAND="$1"
+
+[ "$VCSH_COMMAND" = 'clon' ]   || [ "$VCSH_COMMAND" = 'clo' ]   || [ "$VCSH_COMMAND" = 'cl' ]                                                                && VCSH_COMMAND='clone'
+[ "$VCSH_COMMAND" = 'commi' ]  || [ "$VCSH_COMMAND" = 'comm' ]  || [ "$VCSH_COMMAND" = 'com' ]  || [ "$VCSH_COMMAND" = 'co' ]                                && VCSH_COMMAND='commit'
+[ "$VCSH_COMMAND" = 'delet' ]  || [ "$VCSH_COMMAND" = 'dele' ]  || [ "$VCSH_COMMAND" = 'del' ]  || [ "$VCSH_COMMAND" = 'de' ]                                && VCSH_COMMAND='delete'
+[ "$VCSH_COMMAND" = 'ente' ]   || [ "$VCSH_COMMAND" = 'ent' ]   || [ "$VCSH_COMMAND" = 'en' ]                                                                && VCSH_COMMAND='enter'
+[ "$VCSH_COMMAND" = 'hel' ]    || [ "$VCSH_COMMAND" = 'he' ]                                                                                                 && VCSH_COMMAND='help'
+[ "$VCSH_COMMAND" = 'ini' ]    || [ "$VCSH_COMMAND" = 'in' ]                                                                                                 && VCSH_COMMAND='init'
+[ "$VCSH_COMMAND" = 'pul' ]                                                                                                                                  && VCSH_COMMAND='pull'
+[ "$VCSH_COMMAND" = 'pus' ]                                                                                                                                  && VCSH_COMMAND='push'
+[ "$VCSH_COMMAND" = 'renam' ]  || [ "$VCSH_COMMAND" = 'rena' ]  || [ "$VCSH_COMMAND" = 'ren' ]  || [ "$VCSH_COMMAND" = 're' ]                                && VCSH_COMMAND='rename'
+[ "$VCSH_COMMAND" = 'ru' ]                                                                                                                                   && VCSH_COMMAND='run'
+[ "$VCSH_COMMAND" = 'statu' ]  || [ "$VCSH_COMMAND" = 'stat' ]  || [ "$VCSH_COMMAND" = 'sta' ]  || [ "$VCSH_COMMAND" = 'st' ]                                && VCSH_COMMAND='status'
+[ "$VCSH_COMMAND" = 'upgrad' ] || [ "$VCSH_COMMAND" = 'upgra' ] || [ "$VCSH_COMMAND" = 'upgr' ] || [ "$VCSH_COMMAND" = 'upg' ]                               && VCSH_COMMAND='upgrade'
+[ "$VCSH_COMMAND" = 'versio' ] || [ "$VCSH_COMMAND" = 'versi' ] || [ "$VCSH_COMMAND" = 'vers' ] || [ "$VCSH_COMMAND" = 'ver' ] || [ "$VCSH_COMMAND" = 've' ] && VCSH_COMMAND='version'
+[ "$VCSH_COMMAND" = 'whic' ]   || [ "$VCSH_COMMAND" = 'whi' ]   || [ "$VCSH_COMMAND" = 'wh' ]                                                                && VCSH_COMMAND='which'
+[ "$VCSH_COMMAND" = 'write' ]  || [ "$VCSH_COMMAND" = 'writ' ]  || [ "$VCSH_COMMAND" = 'wri' ]  || [ "$VCSH_COMMAND" = 'wr' ]                                && VCSH_COMMAND='write-gitignore'
 
+
+if [ "$VCSH_COMMAND" = 'clone' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
+	GIT_REMOTE="$2"
+	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+	export VCSH_REPO_NAME
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+elif [ "$VCSH_COMMAND" = 'version' ]; then
+	echo "$SELF $VERSION"
+	exit
+elif [ "$VCSH_COMMAND" = 'which' ]; then
+	[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a filename" 1
+	[ -n "$3" ] && fatal "$VCSH_COMMAND: too many parameters" 1
+	export VCSH_COMMAND_PARAMETER="$2"
+elif [ "$VCSH_COMMAND" = 'delete' ]           ||
+     [ "$VCSH_COMMAND" = 'enter' ]            ||
+     [ "$VCSH_COMMAND" = 'init' ]             ||
+     [ "$VCSH_COMMAND" = 'list-tracked-by' ]  ||
+     [ "$VCSH_COMMAND" = 'rename' ]           ||
+     [ "$VCSH_COMMAND" = 'run' ]              ||
+     [ "$VCSH_COMMAND" = 'upgrade' ]          ||
+     [ "$VCSH_COMMAND" = 'write-gitignore' ]; then
+	[ -z $2 ]                                 && fatal "$VCSH_COMMAND: please specify repository to work on" 1
+	[ "$VCSH_COMMAND" = 'rename' -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a target name" 1
+	[ "$VCSH_COMMAND" = 'run'    -a -z "$3" ] && fatal "$VCSH_COMMAND: please specify a command" 1
+	export VCSH_REPO_NAME="$2"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
+	                                    export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
+	[ "$VCSH_COMMAND" = 'run' ]    && shift 2
+elif [ "$VCSH_COMMAND" = 'commit' ] ||
+     [ "$VCSH_COMMAND" = 'list' ] ||
+     [ "$VCSH_COMMAND" = 'list-tracked' ] ||
+     [ "$VCSH_COMMAND" = 'pull' ] ||
+     [ "$VCSH_COMMAND" = 'push' ]; then
+	:
+elif [ "$VCSH_COMMAND" = 'status' ]; then
+	export VCSH_REPO_NAME="$2"
+elif [ -n "$2" ]; then
+	export VCSH_COMMAND='run'
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
+	shift 1
+	set -- "git" "$@"
+elif [ -n "$VCSH_COMMAND" ]; then
+	export VCSH_COMMAND='enter'
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
 else
-	verbose "defaulting to calling help()"
-	help
-	echo "$SELF: fatal: You should never reach this code. File a bug, please."
-	return 99
+	# $1 is empty, or 'help'
+	help && exit
+fi
 
+# Did we receive a directory instead of a name?
+# Mangle the input to fit normal operation.
+if echo $VCSH_REPO_NAME | grep -q '/'; then
+	export GIT_DIR=$VCSH_REPO_NAME
+	export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
 fi
+
+check_dir() {
+	check_directory="$1"
+	if [ ! -d "$check_directory" ]; then
+		if [ -e "$check_directory" ]; then
+			fatal "'$check_directory' exists but is not a directory" 13
+		else
+			verbose "attempting to create '$check_directory'"
+			mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+		fi
+	fi
+}
+
+check_dir "$VCSH_REPO_D"
+[ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
+
+verbose "$VCSH_COMMAND begin"
+export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
+hook pre-command
+$VCSH_COMMAND "$@"
+hook post-command
+verbose "$VCSH_COMMAND end, exiting"